import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

public class Prog extends Node {
	public List<Reg> regs;
	public List<Proc> procs;
	public Bloco corpo;
	
	public static TabSimb<Proc> eprocs = new TabSimb<Proc>();
	public static TabSimb<Reg> eregs = new TabSimb<Reg>();
	
	public Prog(List<Reg> _regs, List<Proc> _procs, Bloco cs) {
		super(cs.lin);
		regs = _regs;
		procs = _procs;
		corpo = cs;
	}
	
	public void checaTipo() {
		Tipo.subtipoDe.put("nil", new HashSet<String>());
		for(Reg reg: regs) {
			eregs.inserir(reg.nome, reg, reg.lin);
			Tipo.subtipoDe.get("nil").add(reg.nome);
		}
		for(Proc proc: procs) {
			eprocs.inserir(proc.nome, proc, proc.lin);
		}
		TabSimb<String> egvars = corpo.checaTipo(null);
		for(Proc proc: procs) {
			TabSimb<String> eproc = new TabSimb<String>(egvars);
			eproc.inserir(proc.nome, proc.tret, proc.lin);
			for(int i = 0; i < proc.pnomes.size(); i++) {
				eproc.inserir(proc.pnomes.get(i),
							  proc.ptipos.get(i),
							  proc.lin);
			}
			proc.corpo.checaTipo(eproc);
		}
	}
	
	public String geraCodigo(String fmain) {
		List<String> globais = new ArrayList<String>();
		List<String> fnames = new ArrayList<String>();
		List<String> funcs = new ArrayList<String>();
		Contexto cmain = new Contexto(fmain, 0);
		TabSimb<Endereco> egvars = corpo.geraCodigo(cmain, null, true);
		cmain.icload(0); // valor de retorno de "main"
		for(String global: egvars.mapa.keySet()) {
			globais.add(global);
		}
		fnames.add(fmain);
		funcs.add(cmain.codigo());
		for(Proc proc: procs) {
			Contexto cproc = new Contexto(proc.nome, proc.pnomes.size());
			TabSimb<Endereco> eproc = new TabSimb<Endereco>(egvars);
			for(int i = 0; i < proc.pnomes.size(); i++) {
				eproc.inserir(proc.pnomes.get(i),
						      cproc.local(),
							  proc.lin);
			}
			// local para valor de retorno
			eproc.inserir(proc.nome, cproc.local(), proc.lin);
			proc.corpo.geraCodigo(cproc, eproc, false);
			// empilha valor de retorno de proc
			eproc.procurar(proc.nome, proc.lin).load(cproc); // empilhar valor de retorno
			fnames.add(proc.nome);
			funcs.add(cproc.codigo());
		}
		return Contexto.programa(globais, fnames, funcs);
	}
}
